let _ = Mltop.add_known_module "rocq-elpi.elpi"

# 7 "src/rocq_elpi_vernacular_syntax.mlg"
 

open Stdarg
open Ltac_plugin

open Pcoq.Constr

open Rocq_elpi_arg_syntax
module EV = Rocq_elpi_vernacular
module EA = Rocq_elpi_arg_HOAS
module U = Rocq_elpi_utils




# 23 "src/rocq_elpi_vernacular_syntax.mlg"
 
let pr_elpi_code _ _ _ (s : Elpi.API.Ast.Loc.t * string) = Pp.str (snd s)


let (wit_elpi_code, elpi_code) = Tacentries.argument_extend ~plugin:"rocq-elpi.elpi" ~name:"elpi_code" 
                                 {
                                 Tacentries.arg_parsing = Vernacextend.Arg_rules (
                                                          []);
                                 Tacentries.arg_tag = None;
                                 Tacentries.arg_intern = Tacentries.ArgInternFun (fun ist v -> (ist, v));
                                 Tacentries.arg_subst = Tacentries.ArgSubstFun (fun s v -> v);
                                 Tacentries.arg_interp = Tacentries.ArgInterpRet;
                                 Tacentries.arg_printer = ((fun env sigma -> 
                                                          
# 28 "src/rocq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ), (fun env sigma -> 
                                                          
# 28 "src/rocq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ), (fun env sigma -> 
                                                          
# 28 "src/rocq_elpi_vernacular_syntax.mlg"
                 pr_elpi_code 
                                                          ));
                                 }
let _ = (wit_elpi_code, elpi_code)


# 30 "src/rocq_elpi_vernacular_syntax.mlg"
 
let () = Rocq_elpi_glob_quotation.is_elpi_code :=
           (fun x -> Genarg.(has_type x (glbwit wit_elpi_code)))
let () = Rocq_elpi_glob_quotation.get_elpi_code :=
           (fun x -> Genarg.(out_gen (glbwit wit_elpi_code) x))

let pr_elpi_code_appArg _ _ _ (s : Elpi.API.Ast.Loc.t * string list) = Pp.prlist Pp.str (snd s)

let pr_ghost_loc _ _ _ loc = Loc.pr loc


let (wit_ghost, ghost) = Tacentries.argument_extend ~plugin:"rocq-elpi.elpi" ~name:"ghost" 
                         {
                         Tacentries.arg_parsing = Vernacextend.Arg_rules (
                                                  [(Pcoq.Production.make
                                                    (Pcoq.Rule.stop)
                                                    (fun loc -> 
# 42 "src/rocq_elpi_vernacular_syntax.mlg"
           loc 
                                                                ))]);
                         Tacentries.arg_tag = None;
                         Tacentries.arg_intern = Tacentries.ArgInternFun (fun ist v -> (ist, v));
                         Tacentries.arg_subst = Tacentries.ArgSubstFun (fun s v -> v);
                         Tacentries.arg_interp = Tacentries.ArgInterpRet;
                         Tacentries.arg_printer = ((fun env sigma -> 
                                                  
# 41 "src/rocq_elpi_vernacular_syntax.mlg"
                                   pr_ghost_loc 
                                                  ), (fun env sigma -> 
                                                  
# 41 "src/rocq_elpi_vernacular_syntax.mlg"
                                   pr_ghost_loc 
                                                  ), (fun env sigma -> 
                                                  
# 41 "src/rocq_elpi_vernacular_syntax.mlg"
                                   pr_ghost_loc 
                                                  ));
                         }
let _ = (wit_ghost, ghost)

let (wit_elpi_code_appArg, elpi_code_appArg) = Tacentries.argument_extend ~plugin:"rocq-elpi.elpi" ~name:"elpi_code_appArg" 
                                               {
                                               Tacentries.arg_parsing = 
                                               Vernacextend.Arg_rules (
                                               []);
                                               Tacentries.arg_tag = None;
                                               Tacentries.arg_intern = 
                                               Tacentries.ArgInternFun (fun ist v -> (ist, v));
                                               Tacentries.arg_subst = 
                                               Tacentries.ArgSubstFun (fun s v -> v);
                                               Tacentries.arg_interp = 
                                               Tacentries.ArgInterpRet;
                                               Tacentries.arg_printer = 
                                               ((fun env sigma -> 
# 46 "src/rocq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ), (fun env sigma -> 
# 46 "src/rocq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ), (fun env sigma -> 
# 46 "src/rocq_elpi_vernacular_syntax.mlg"
               pr_elpi_code_appArg 
                                               ));
                                               }
let _ = (wit_elpi_code_appArg, elpi_code_appArg)


# 48 "src/rocq_elpi_vernacular_syntax.mlg"
 

let () = Rocq_elpi_glob_quotation.is_elpi_code_appArg  :=
           (fun x -> Genarg.(has_type x (glbwit wit_elpi_code_appArg )))
let () = Rocq_elpi_glob_quotation.get_elpi_code_appArg  :=
           (fun x -> Genarg.(out_gen (glbwit wit_elpi_code_appArg ) x))

let rec inlogpath q = function
  | [] -> []
  | x :: xs -> (Libnames.string_of_qualid q ^ "/" ^ x) :: inlogpath q xs

let warning_legacy_typecheck =
  CWarnings.create ~name:"elpi.typecheck-syntax" ~category:Rocq_elpi_utils.elpi_depr_cat (fun () ->
    Pp.strbrk "The command 'Elpi Typecheck' is deprecated (and does nothing) since type checking is now performed by 'Elpi Accumulate'.")

let warning_legacy_accumulate_gen =
  CWarnings.create ~default:CWarnings.AsError ~name:"elpi.accumulate-syntax" ~category:Rocq_elpi_utils.elpi_depr_cat (fun has_from ->
      if has_from then
        Pp.strbrk "The syntax 'Elpi Accumulate File \"path\"' is deprecated, use 'Elpi Accumulate File \"path\" From logpath'"
      else Pp.strbrk "The syntax 'Elpi Accumulate File \"path\" From logpath' is deprecated, use 'From logpath Extra Dependency \"path\" as name. Elpi Accumulate File name.'")

let warning_legacy_accumulate ?loc () = warning_legacy_accumulate_gen ?loc true
let warning_legacy_accumulate2 ?loc () = warning_legacy_accumulate_gen ?loc false

let lib_ref id =
  let id = String.concat "." (snd id) in
  try Coqlib.lib_ref id
  with Coqlib.NotFoundRef _ ->
    CErrors.user_err
      Pp.(str "Global reference not found: lib:" ++ str id
          ++ str " (you may need to require some .v file with \
                  `Register ... as " ++ str id ++ str ".`).")



let _ = let () =
        Egramml.grammar_extend ~plugin_uid:("rocq-elpi.elpi", "rocq_elpi_vernacular_syntax.mlg:0")
        term
        (Pcoq.Reuse (Some
        ("0"), [Pcoq.Production.make
                (Pcoq.Rule.next (Pcoq.Rule.stop)
                                ((Pcoq.Symbol.token (Tok.PQUOTATION "lp:"))))
                (fun s loc -> 
# 86 "src/rocq_elpi_vernacular_syntax.mlg"
          
          let loc = { loc with Loc.bp = loc.Loc.bp + 3 } in
          let arg =
            if s.[0] = '('
            then Genarg.in_gen (Genarg.rawwit wit_elpi_code_appArg) (idents_of loc s)
            else if s.[0] = '\123'
            then Genarg.in_gen (Genarg.rawwit wit_elpi_code) (strip_curly loc s)
            else Genarg.in_gen (Genarg.rawwit wit_elpi_code) (Rocq_elpi_utils.of_coq_loc loc,s) in
          CAst.make ~loc
            (Constrexpr.CGenarg arg) 
                              )]))
        in ()

let _ = let () =
        Egramml.grammar_extend ~plugin_uid:("rocq-elpi.elpi", "rocq_elpi_vernacular_syntax.mlg:1")
        term
        (Pcoq.Reuse (Some
        ("0"), [Pcoq.Production.make
                (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next 
                                                                (Pcoq.Rule.stop)
                                                                ((Pcoq.Symbol.token (Tok.PKEYWORD ("lib")))))
                                                                ((Pcoq.Symbol.token (Tok.PKEYWORD (":")))))
                                                ((Pcoq.Symbol.token (Tok.PKEYWORD ("@")))))
                                ((Pcoq.Symbol.nterm qualified_name)))
                (fun id _ _ _ loc -> 
# 108 "src/rocq_elpi_vernacular_syntax.mlg"
                                                 
          let ref = lib_ref id in
          let path = Nametab.path_of_global ref in
          let f = Libnames.qualid_of_path ~loc:(fst id) path in
          CAst.make ~loc Constrexpr.(CAppExpl((f,None),[])) 
                                     );
               Pcoq.Production.make
               (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.next (Pcoq.Rule.stop)
                                                               ((Pcoq.Symbol.token (Tok.PKEYWORD ("lib")))))
                                               ((Pcoq.Symbol.token (Tok.PKEYWORD (":")))))
                               ((Pcoq.Symbol.nterm qualified_name)))
               (fun id _ _ loc -> 
# 104 "src/rocq_elpi_vernacular_syntax.mlg"
                                            
          let ref = lib_ref id in
          let path = Nametab.path_of_global ref in
          CAst.make ~loc Constrexpr.(CRef (Libnames.qualid_of_path ~loc:(fst id) path,None)) 
                                  )]))
        in ()


# 118 "src/rocq_elpi_vernacular_syntax.mlg"
 
let classify_named_vernac (_,p) = Vernacextend.VtSideff([Names.Id.of_string_soft @@ String.concat "." p],VtNow)


let () = Vernacextend.static_vernac_extend ~plugin:(Some "rocq-elpi.elpi") ~command:"ElpiNamed"  ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Program", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                     Vernacextend.TyNil))))), (let coqpp_body gloc
                                                              p s
                                                              atts = 
                                                              (let atts = 
                                                              
# 124 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes raw_args_attributes atts in
     EV.Synterp.create_program ~atts ~loc:gloc ~init:s p;
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 128 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_program ~atts ~loc:gloc ~init:s p
   
                                                              )) in fun gloc
                                                              p s
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p s
                                                              (Attributes.parse 
                                                              
# 123 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), Some 
         (fun gloc p s -> 
# 123 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                   classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Command", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil)))), (let coqpp_body gloc
                                                            p
                                                            atts = (let atts = 
                                                                   
# 132 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes raw_args_attributes atts in
     EV.Synterp.create_command ~atts ~loc:gloc p;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 136 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_command ~atts ~loc:gloc p 
                                                                   )) in fun gloc
                                                            p ?loc ~atts ()
                                                            -> coqpp_body gloc
                                                            p
                                                            (Attributes.parse 
                                                            
# 131 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), Some 
         (fun gloc p -> 
# 131 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                    classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Tactic", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil)))), (let coqpp_body gloc
                                                            p
                                                            atts = (let _ = 
                                                                   
# 139 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.create_tactic ~loc:gloc p
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 142 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_tactic ~loc:gloc p 
                                                                   )) in fun gloc
                                                            p ?loc ~atts ()
                                                            -> coqpp_body gloc
                                                            p
                                                            (Attributes.parse 
                                                            
# 138 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), Some 
         (fun gloc p -> 
# 138 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                   classify_named_vernac p 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                                                   Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                                   Vernacextend.TyNil))))), 
         (let coqpp_body gloc d s
         atts = (let atts = 
# 145 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.create_db ~atts ~loc:gloc d ~init:s;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 149 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_db ~atts ~loc:gloc d ~init:s 
                )) in fun gloc
         d s ?loc ~atts () -> coqpp_body gloc d s (Attributes.parse 
# 144 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), Some (fun gloc d s -> 
# 144 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                              classify_named_vernac d 
                       )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             d s
                                                             atts = (let atts = 
                                                                    
# 152 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.create_file ~atts ~loc:gloc d ~init:s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 156 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.create_file ~atts ~loc:gloc d ~init:s 
                                                                    )) in fun gloc
                                                             d s
                                                             ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             d s
                                                             (Attributes.parse 
                                                             
# 151 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), Some 
         (fun gloc d s -> 
# 151 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                classify_named_vernac d 
         )))]

let () = Vernacextend.static_vernac_extend ~plugin:(Some "rocq-elpi.elpi") ~command:"ElpiAccumulate" ~classifier:(fun _ -> Vernacextend.classify_as_sideeff) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Accumulate", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                     Vernacextend.TyTerminal ("File", 
                                     Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                 Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                     Vernacextend.TyNil))))), (let coqpp_body gloc
                                                              ids
                                                              atts = 
                                                              (let atts = 
                                                              
# 161 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                    
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~what:Code (List.map snd ids);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 165 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~what:Code (List.map snd ids) 
                                                              )) in fun gloc
                                                              ids
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              ids
                                                              (Attributes.parse 
                                                              
# 161 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             ids
                                                             atts = (let atts = 
                                                                    
# 167 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                     
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~what:Code (List.map snd ids);
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 171 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~what:Code (List.map snd ids) 
                                                                    )) in fun gloc
                                                             ids
                                                             ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             ids
                                                             (Attributes.parse 
                                                             
# 167 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p ids
                                                              atts = 
                                                              (let atts = 
                                                              
# 173 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                      
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Code (List.map snd ids);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 177 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Code (List.map snd ids) 
                                                              )) in fun gloc
                                                              p ids
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p ids
                                                              (Attributes.parse 
                                                              
# 173 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p ids
                                                              atts = 
                                                              (let atts = 
                                                              
# 179 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                       
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Code (List.map snd ids);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 183 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Code (List.map snd ids) 
                                                              )) in fun gloc
                                                              p ids
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p ids
                                                              (Attributes.parse 
                                                              
# 179 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyTerminal ("Signature", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              ids
                                                              atts = 
                                                              (let atts = 
                                                              
# 185 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~what:Signature (List.map snd ids);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 189 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~what:Signature (List.map snd ids) 
                                                              )) in fun gloc
                                                              ids
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              ids
                                                              (Attributes.parse 
                                                              
# 185 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyTerminal ("Signature", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              ids
                                                              atts = 
                                                              (let atts = 
                                                              
# 191 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                 
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~what:Signature (List.map snd ids);
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 195 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~what:Signature (List.map snd ids) 
                                                              )) in fun gloc
                                                              ids
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              ids
                                                              (Attributes.parse 
                                                              
# 191 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyTerminal ("Signature", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil))))))), (let coqpp_body gloc
                                                               p ids
                                                               atts = 
                                                               (let atts = 
                                                               
# 197 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                                  
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Signature (List.map snd ids);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 201 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Signature (List.map snd ids) 
                                                               )) in fun gloc
                                                               p ids
                                                               ?loc ~atts ()
                                                               -> coqpp_body gloc
                                                               p ids
                                                               (Attributes.parse 
                                                               
# 197 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyTerminal ("Signature", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist1 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_qualified_name)), 
                                    Vernacextend.TyNil))))))), (let coqpp_body gloc
                                                               p ids
                                                               atts = 
                                                               (let atts = 
                                                               
# 203 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                                   
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Signature (List.map snd ids);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 207 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_extra_deps ~atts ~loc:gloc ~program:(snd p) ~what:Signature (List.map snd ids) 
                                                               )) in fun gloc
                                                               p ids
                                                               ?loc ~atts ()
                                                               -> coqpp_body gloc
                                                               p ids
                                                               (Attributes.parse 
                                                               
# 203 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             s
                                                             atts = (let atts = 
                                                                    
# 212 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                        warning_legacy_accumulate ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 216 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc s 
                                                                    )) in fun gloc
                                                             s ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             s
                                                             (Attributes.parse 
                                                             
# 212 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil))))))), (let coqpp_body gloc
                                                               s g
                                                               atts = 
                                                               (let atts = 
                                                               
# 218 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                         warning_legacy_accumulate2 ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc (inlogpath g s);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 222 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc (inlogpath g s) 
                                                               )) in fun gloc
                                                               s g
                                                               ?loc ~atts ()
                                                               -> coqpp_body gloc
                                                               s g
                                                               (Attributes.parse 
                                                               
# 218 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             s
                                                             atts = (let atts = 
                                                                    
# 224 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                         warning_legacy_accumulate ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 228 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc s 
                                                                    )) in fun gloc
                                                             s ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             s
                                                             (Attributes.parse 
                                                             
# 224 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil))))))), (let coqpp_body gloc
                                                               s g
                                                               atts = 
                                                               (let atts = 
                                                               
# 230 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                          warning_legacy_accumulate2 ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc (inlogpath g s);
     atts
   
                                                                in Vernactypes.vtdefault (fun () -> 
                                                               
# 234 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc (inlogpath g s) 
                                                               )) in fun gloc
                                                               s g
                                                               ?loc ~atts ()
                                                               -> coqpp_body gloc
                                                               s g
                                                               (Attributes.parse 
                                                               
# 230 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNil)))), (let coqpp_body gloc
                                                            s
                                                            atts = (let atts = 
                                                                   
# 236 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_string ~atts ~loc:gloc s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 240 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_string ~atts ~loc:gloc s 
                                                                   )) in fun gloc
                                                            s ?loc ~atts ()
                                                            -> coqpp_body gloc
                                                            s
                                                            (Attributes.parse 
                                                            
# 236 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p s
                                                              atts = 
                                                              (let atts = 
                                                              
# 242 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                          warning_legacy_accumulate ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc ~program:(snd p) s;
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 246 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc ~program:(snd p) s 
                                                              )) in fun gloc
                                                              p s
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p s
                                                              (Attributes.parse 
                                                              
# 242 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("File", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil)))))))), (let coqpp_body gloc
                                                                p s g
                                                                atts = 
                                                                (let atts = 
                                                                
# 248 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                           warning_legacy_accumulate2 ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc ~program:(snd p) (inlogpath g s);
     atts
   
                                                                 in Vernactypes.vtdefault (fun () -> 
                                                                
# 252 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc ~program:(snd p) (inlogpath g s) 
                                                                )) in fun gloc
                                                                p s g
                                                                ?loc ~atts ()
                                                                -> coqpp_body gloc
                                                                p s g
                                                                (Attributes.parse 
                                                                
# 248 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                 atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p s
                                                              atts = 
                                                              (let atts = 
                                                              
# 254 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                           warning_legacy_accumulate ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc ~program:(snd p) s;
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 258 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc ~program:(snd p) s 
                                                              )) in fun gloc
                                                              p s
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p s
                                                              (Attributes.parse 
                                                              
# 254 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Files", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("From", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_global), 
                                    Vernacextend.TyNil)))))))), (let coqpp_body gloc
                                                                p s g
                                                                atts = 
                                                                (let atts = 
                                                                
# 260 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                            warning_legacy_accumulate2 ();
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_files ~atts ~loc:gloc ~program:(snd p) (inlogpath g s);
     atts
   
                                                                 in Vernactypes.vtdefault (fun () -> 
                                                                
# 264 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_files ~atts ~loc:gloc ~program:(snd p) (inlogpath g s) 
                                                                )) in fun gloc
                                                                p s g
                                                                ?loc ~atts ()
                                                                -> coqpp_body gloc
                                                                p s g
                                                                (Attributes.parse 
                                                                
# 260 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                                 atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             p s
                                                             atts = (let atts = 
                                                                    
# 269 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                  
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_string ~atts ~loc:gloc ~program:(snd p) s;
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 273 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_string ~atts ~loc:gloc ~program:(snd p) s 
                                                                    )) in fun gloc
                                                             p s
                                                             ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             p s
                                                             (Attributes.parse 
                                                             
# 269 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil))))), 
         (let coqpp_body gloc d
         atts = (let atts = 
# 275 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                        
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db ~atts ~loc:gloc (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 279 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db ~atts ~loc:gloc (snd d) 
                )) in fun gloc
         d ?loc ~atts () -> coqpp_body gloc d (Attributes.parse 
# 275 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil)))))), 
         (let coqpp_body gloc p d
         atts = (let atts = 
# 281 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                           
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db ~atts ~loc:gloc ~program:(snd p) (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 285 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db ~atts ~loc:gloc ~program:(snd p) (snd d) 
                )) in fun gloc
         p d ?loc ~atts () -> coqpp_body gloc p d (Attributes.parse 
# 281 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyTerminal ("Header", 
                                                                   Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil)))))), 
         (let coqpp_body gloc d
         atts = (let atts = 
# 287 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                 
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db_header ~atts ~loc:gloc (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 291 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db_header ~atts ~loc:gloc (snd d) 
                )) in fun gloc
         d ?loc ~atts () -> coqpp_body gloc d (Attributes.parse 
# 287 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Accumulate", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("Db", Vernacextend.TyTerminal ("Header", 
                                                                   Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil))))))), 
         (let coqpp_body gloc p d
         atts = (let atts = 
# 293 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                    
     let atts = validate_attributes scope_and_skip_and_synterp_attributes atts in
     EV.Synterp.accumulate_db_header ~atts ~loc:gloc ~program:(snd p) (snd d);
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 297 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.accumulate_db_header ~atts ~loc:gloc ~program:(snd p) (snd d) 
                )) in fun gloc
         p d ?loc ~atts () -> coqpp_body gloc p d (Attributes.parse 
# 293 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None))]

let () = Vernacextend.static_vernac_extend ~plugin:(Some "rocq-elpi.elpi") ~command:"ElpiUnnamed" ~classifier:(fun _ -> Vernacextend.classify_as_sideeff) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Debug", 
                                     Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                 Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                     Vernacextend.TyNil))), (let coqpp_body s
                                                            atts = (let atts = 
                                                                   
# 302 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                               
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.debug  ~atts s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 306 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.debug  ~atts s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse 
                                                            
# 302 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyTerminal ("Browser", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))), (let coqpp_body s
                                                            atts = (let atts = 
                                                                   
# 308 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                         
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace_browser  ~atts s;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 312 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace_browser  ~atts s 
                                                                   )) in fun s
                                                            ?loc ~atts ()
                                                            -> coqpp_body s
                                                            (Attributes.parse 
                                                            
# 308 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))), (let coqpp_body s
                                                           atts = (let atts = 
                                                                  
# 314 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                               
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 1 max_int s [];
     atts
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 318 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts 1 max_int s [] 
                                                                  )) in fun s
                                                           ?loc ~atts ()
                                                           -> coqpp_body s
                                                           (Attributes.parse 
                                                           
# 314 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                            atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("/", Vernacextend.TyNonTerminal (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                                                  Vernacextend.TyNil))))), 
         (let coqpp_body s o
         atts = (let atts = 
# 320 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                  
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 1 max_int s o;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 324 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace ~atts 1 max_int s o 
                )) in fun s
         o ?loc ~atts () -> coqpp_body s o (Attributes.parse 
# 320 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil))))), (let coqpp_body start
                                                             stop s
                                                             atts = (let atts = 
                                                                    
# 326 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                      
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts start stop s [];
     atts
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 330 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace ~atts start stop s [] 
                                                                    )) in fun start
                                                             stop s
                                                             ?loc ~atts ()
                                                             -> coqpp_body start
                                                             stop s
                                                             (Attributes.parse 
                                                             
# 326 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyTerminal ("/", Vernacextend.TyNonTerminal (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                                                  Vernacextend.TyNil))))))), 
         (let coqpp_body start stop s o
         atts = (let atts = 
# 332 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                       
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts start stop s o;
     atts
   
                 in Vernactypes.vtdefault (fun () -> 
# 336 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts start stop s o 
                )) in fun start
         stop s o ?loc ~atts () -> coqpp_body start stop s o
         (Attributes.parse 
# 332 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Trace", 
                                    Vernacextend.TyTerminal ("Off", Vernacextend.TyNil))), 
         (let coqpp_body atts = (let atts = 
# 339 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                      
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.trace  ~atts 0 0 [] [];
     atts
   
                                 in Vernactypes.vtdefault (fun () -> 
                                
# 343 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.trace  ~atts 0 0 [] [] 
                                )) in fun ?loc ~atts ()
         -> coqpp_body (Attributes.parse 
# 339 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Bound", 
                                    Vernacextend.TyTerminal ("Steps", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_int), 
                                    Vernacextend.TyNil)))), (let coqpp_body steps
                                                            atts = (let atts = 
                                                                   
# 345 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                   
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.bound_steps  ~atts steps;
     atts
   
                                                                    in Vernactypes.vtdefault (fun () -> 
                                                                   
# 349 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.bound_steps  ~atts steps 
                                                                   )) in fun steps
                                                            ?loc ~atts ()
                                                            -> coqpp_body steps
                                                            (Attributes.parse 
                                                            
# 345 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                             atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Print", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_string)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p output args
                                                              atts = 
                                                              (let atts = 
                                                              
# 352 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                               
     let atts = validate_attributes synterp_attribute atts in
     EV.Synterp.print ~atts ~loc:gloc ~name:(snd p) ~args output;
     atts
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 356 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.print  ~atts ~loc:gloc ~name:(snd p) ~args output; 
                                                              )) in fun gloc
                                                              p output args
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p output args
                                                              (Attributes.parse 
                                                              
# 352 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Typecheck", 
                                    Vernacextend.TyNil)), (let coqpp_body atts = 
                                                          (let _ = 
# 360 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     warning_legacy_typecheck ()
   
                                                           in Vernactypes.vtdefault (fun () -> 
                                                          
# 363 "src/rocq_elpi_vernacular_syntax.mlg"
         
     warning_legacy_typecheck () 
                                                          )) in fun ?loc ~atts ()
                                                          -> coqpp_body (Attributes.parse 
                                                          
# 359 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                           atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Typecheck", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let _ = 
                                                                  
# 366 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     warning_legacy_typecheck ()
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 369 "src/rocq_elpi_vernacular_syntax.mlg"
         
     let () = ignore_unknown_attributes atts in
     warning_legacy_typecheck () 
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse 
                                                           
# 365 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                            atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Document", 
                                    Vernacextend.TyTerminal ("Builtins", 
                                    Vernacextend.TyNil))), (let coqpp_body atts = 
                                                           Vernactypes.vtdefault (fun () -> 
                                                           
# 373 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                 
     let () = ignore_unknown_attributes atts in
     EV.document_builtins () 
                                                           ) in fun ?loc ~atts ()
                                                           -> coqpp_body (Attributes.parse 
                                                           
# 373 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                            atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Template", 
                                    Vernacextend.TyTerminal ("Command", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              syn int
                                                              atts = 
                                                              (let _ = 
                                                              
# 376 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                              
     let () = ignore_unknown_attributes atts in
     EV.Synterp.load_command ~loc:gloc syn
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 379 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_command ~loc:gloc int 
                                                              )) in fun gloc
                                                              syn int
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              syn int
                                                              (Attributes.parse 
                                                              
# 376 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Template", 
                                    Vernacextend.TyTerminal ("Tactic", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_string), 
                                    Vernacextend.TyNil))))), (let coqpp_body gloc
                                                             s
                                                             atts = (let _ = 
                                                                    
# 381 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                               
     let () = ignore_unknown_attributes atts in
     () (* no synterp tactics  EV.Synterp.load_tactic syn *)
   
                                                                     in Vernactypes.vtdefault (fun () -> 
                                                                    
# 384 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.load_tactic ~loc:gloc s 
                                                                    )) in fun gloc
                                                             s ?loc ~atts ()
                                                             -> coqpp_body gloc
                                                             s
                                                             (Attributes.parse 
                                                             
# 381 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                              atts)), None))]

let () = Vernacextend.static_vernac_extend ~plugin:(Some "rocq-elpi.elpi") ~command:"ElpiRun" ~classifier:( fun _ -> Vernacextend.(VtSideff ([], VtNow)) ) ?entry:None 
         [(Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                     Vernacextend.TyTerminal ("Query", 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                     Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                     Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                 Extend.TUentry (Genarg.get_arg_tag wit_elpi_string)), 
                                     Vernacextend.TyNil))))), (let coqpp_body gloc
                                                              synterp interp
                                                              atts = 
                                                              (let syndata = 
                                                              
# 390 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     match synterp with
     | Some synterp -> EV.Synterp.run_in_program ~loc:gloc synterp
     | None -> None
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 396 "src/rocq_elpi_vernacular_syntax.mlg"
         
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     EV.Interp.run_in_program ~loc:gloc ~syndata interp 
                                                              )) in fun gloc
                                                              synterp interp
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              synterp interp
                                                              (Attributes.parse 
                                                              
# 389 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Query", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                    Vernacextend.TyNonTerminal (Extend.TUopt (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_elpi_string)), 
                                    Vernacextend.TyNil)))))), (let coqpp_body gloc
                                                              p synterp
                                                              interp
                                                              atts = 
                                                              (let syndata = 
                                                              
# 400 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     match synterp with
     | Some synterp -> EV.Synterp.run_in_program ~loc:gloc synterp
     | None -> None
   
                                                               in Vernactypes.vtdefault (fun () -> 
                                                              
# 406 "src/rocq_elpi_vernacular_syntax.mlg"
         
     let synterp, interp = match interp with None -> None, synterp | Some interp -> Some synterp, interp in
     EV.Interp.run_in_program ~loc:gloc ~program:(snd p) ~syndata interp 
                                                              )) in fun gloc
                                                              p synterp
                                                              interp
                                                              ?loc ~atts ()
                                                              -> coqpp_body gloc
                                                              p synterp
                                                              interp
                                                              (Attributes.parse 
                                                              
# 399 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                               atts)), None));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Export", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           atts = (let _ = 
                                                                  
# 409 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                          
     EV.export_command (snd p)
  
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 411 "src/rocq_elpi_vernacular_syntax.mlg"
        
     let () = ignore_unknown_attributes atts in  
     ()
  
                                                                  )) in fun p
                                                           ?loc ~atts ()
                                                           -> coqpp_body p
                                                           (Attributes.parse 
                                                           
# 409 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                            atts)), Some 
         (fun p -> 
# 409 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                       Vernacextend.(VtSideff ([],VtNow)) 
         )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyTerminal ("Export", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyTerminal ("As", Vernacextend.TyNonTerminal (
                                                                   Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                   Vernacextend.TyNil))))), 
         (let coqpp_body p q
         atts = (let _ = 
# 415 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                                                                                 
     EV.export_command ~as_:(snd q) (snd p)
  
                 in Vernactypes.vtdefault (fun () -> 
# 417 "src/rocq_elpi_vernacular_syntax.mlg"
        
     let () = ignore_unknown_attributes atts in  
     ()
  
                )) in fun p
         q ?loc ~atts () -> coqpp_body p q (Attributes.parse 
# 415 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
          atts)), Some (fun p q -> 
# 415 "src/rocq_elpi_vernacular_syntax.mlg"
                                                                                              Vernacextend.(VtSideff ([],VtNow)) 
                       )));
         (Vernacextend.TyML (false, Vernacextend.TyTerminal ("Elpi", 
                                    Vernacextend.TyNonTerminal (Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                    Vernacextend.TyNonTerminal (Extend.TUlist0 (
                                                                Extend.TUentry (Genarg.get_arg_tag wit_elpi_cmd_arg)), 
                                    Vernacextend.TyNil))), (let coqpp_body p
                                                           args
                                                           atts = (let syndata = 
                                                                  
# 422 "src/rocq_elpi_vernacular_syntax.mlg"
     
     let () = ignore_unknown_attributes atts in
     EV.Synterp.run_program ~loc:(fst p) (snd p) ~atts args
   
                                                                   in Vernactypes.vtdefault (fun () -> 
                                                                  
# 425 "src/rocq_elpi_vernacular_syntax.mlg"
         
     EV.Interp.run_program ~loc:(fst p) (snd p) ~atts ~syndata args 
                                                                  )) in fun p
                                                           args ?loc ~atts ()
                                                           -> coqpp_body p
                                                           args
                                                           (Attributes.parse 
                                                           
# 421 "src/rocq_elpi_vernacular_syntax.mlg"
             any_attribute
                                                            atts)), None))]

let () = Tacentries.tactic_extend "rocq-elpi.elpi" "elpi_tac" ~level:0 
         [(Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyArg (
                                                        Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                        Tacentries.TyArg (
                                                        Extend.TUlist0 (
                                                        Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                        Tacentries.TyNil))), 
           (fun p args ist -> 
# 431 "src/rocq_elpi_vernacular_syntax.mlg"
    EV.run_tactic ~loc:(fst p) (snd p) ~atts:[] ist args 
           )));
         (Tacentries.TyML (Tacentries.TyIdent ("ltac_attributes", Tacentries.TyIdent (":", 
                                                                  Tacentries.TyIdent ("(", 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_ltac_attributes), 
                                                                  Tacentries.TyIdent (")", 
                                                                  Tacentries.TyIdent ("elpi", 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                                  Tacentries.TyArg (
                                                                  Extend.TUlist0 (
                                                                  Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                                  Tacentries.TyNil)))))))), 
          (fun atts p args ist -> 
# 433 "src/rocq_elpi_vernacular_syntax.mlg"
    EV.run_tactic ~loc:(fst p) (snd p) ~atts ist args 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("#[", Tacentries.TyArg (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_attributes), 
                                                     Tacentries.TyIdent ("]", 
                                                     Tacentries.TyIdent ("elpi", 
                                                     Tacentries.TyArg (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                     Tacentries.TyArg (
                                                     Extend.TUlist0 (
                                                     Extend.TUentry (Genarg.get_arg_tag wit_elpi_tactic_arg)), 
                                                     Tacentries.TyNil)))))), 
          (fun atts p args ist -> 
# 435 "src/rocq_elpi_vernacular_syntax.mlg"
    EV.run_tactic ~loc:(fst p) (snd p) ~atts ist args 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyIdent ("query", 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_ghost), 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                       Tacentries.TyNil)))), 
          (fun gloc s ist -> 
# 437 "src/rocq_elpi_vernacular_syntax.mlg"
    EV.run_in_tactic ~loc:gloc s ist 
          )));
         (Tacentries.TyML (Tacentries.TyIdent ("elpi", Tacentries.TyIdent ("query", 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_qualified_name), 
                                                       Tacentries.TyArg (
                                                       Extend.TUentry (Genarg.get_arg_tag wit_elpi_string), 
                                                       Tacentries.TyNil)))), 
          (fun p s ist -> 
# 439 "src/rocq_elpi_vernacular_syntax.mlg"
    EV.run_in_tactic ~loc:(fst p) s ~program:(snd p) ist 
          )))]

